/*
This is a game demo written by Wingo Sai-Keung Wong.
OGRE is employed for graphics rendering.
CEGUI is employed for GUI.
Date: Dec 2006 - Jan 2007
Email: wingo.wong@gmail.com
*/
#ifndef __COMMON_H__
#define __COMMON_H__
#include "Ogre.h"
#include "common.h"

using namespace Ogre;
namespace ns_Common {
	extern Root *ms_Root;
	extern RenderWindow* ms_Window;
	extern SceneManager *ms_SceneMgr;
	extern SceneNode *ms_CameraNode;
	extern Camera *ms_Camera;
};

#define dg_DEBUG_LOG_MESSAGE
//#undef dg_DEBUG_LOG_MESSAGE

#ifdef dg_DEBUG_LOG_MESSAGE
#define DEBUG_LOG_MSG(msg) LogManager::getSingleton().logMessage(msg);
#define DEBUG_LOG_MSG_INT(msg, v) { char msg0[256]; sprintf(msg0, "%s:%d", msg, (v)); LogManager::getSingleton().logMessage(msg0);} 
#define DEBUG_LOG_MSG_REAL(msg, v) { char msg0[256]; sprintf(msg0, "%s:%f", msg, (v)); LogManager::getSingleton().logMessage(msg0);} 
#define DEBUG_LOG_MSG_POINTER(ptr) { char msg0[256]; sprintf(msg0, "Pointer:%p", (ptr)); LogManager::getSingleton().logMessage(msg0);} 
#define DEBUG_LOG_MSG_MSG_AND_POINTER(msg, ptr) { char o_msg[256]; sprintf(o_msg, "%s, Pointer:%p", msg, (ptr)); LogManager::getSingleton().logMessage(o_msg);} 
#define DEBUG_LOG_MSG_VECTOR3(v) { char msg[128]; sprintf(msg, "Vector3:%f %f %f", v.x, v.y, v.z); LogManager::getSingleton().logMessage(msg);} 
//#define	DEBUG_LOG_MSG(msg)	1;
#else
#define DEBUG_LOG_MSG(msg) 1;
#define DEBUG_LOG_MSG_INT(v) 1;
#define DEBUG_LOG_MSG_POINTER(ptr) 1;
#define DEBUG_LOG_MSG_VECTOR3(ptr) 1;
#define DEBUG_LOG_MSG_MSG_AND_POINTER(msg, ptr) 1;
#endif

using namespace Ogre;

extern void genNameUsingIndex(const String & prefix, int index, String &out_name);
extern void initSceneManagerAndCamera(Root *r, RenderWindow *w, SceneManager *m, Camera *camera, SceneNode *cameraNode);
#endif