#include "coverage_map.h"



WAGO_COVERAGE_MAP::WAGO_COVERAGE_MAP(const String &name, const String &group, uint nx, uint nz, int numChannels)
{
	mData = NULL;
	mWidth = nx;
	mHeight = nz;
	mNumChannels = numChannels;
	mSize = mWidth*mHeight*mNumChannels;
	mData = new uchar[mSize];
	memset(mData, 0, mSize);
	//
	//	String name;
	//generateGlobalObjName(name);
	//String group = ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME;
	DEBUG_LOG_MSG(group.data());
	DEBUG_LOG_MSG(name.data());
	mTexture = TextureManager::getSingleton().createManual(name, group, TEX_TYPE_2D,
        mWidth, mHeight, 1, 0, getFormat(mNumChannels), TU_DEFAULT, this);
}


void WAGO_COVERAGE_MAP::loadMap(const String &filename, const String &res_group)
{		
	Image image;
	image.load(filename, res_group);
	if (mWidth!=image.getWidth() || mHeight!=image.getHeight()) {
		image.resize(mWidth, mHeight);	
	}
	loadFromImage(image);
}